



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>静态类和静态类成员（C# 编程指南）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">静态类和静态类成员（C# 编程指南）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 03:48:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://msdn.microsoft.com/zh-cn/library/98f28cdx.aspx" rel="external nofollow noreferrer">静态</a>类与非静态类基本相同，但存在一个区别：静态类不能实例化。 也就是说，不能使用&nbsp;<a href="https://msdn.microsoft.com/zh-cn/library/51y09td4.aspx" rel="external nofollow noreferrer">new</a>&nbsp;关键字创建静态类类型的变量。 因为没有实例变量，所以要使用类名本身访问静态类的成员。 例如，如果名为&nbsp;<code>UtilityClass</code>&nbsp;的静态类有一个名为&nbsp;<code>MethodA</code>&nbsp;的公共方法，则按下面的示例所示调用该方法：</p>
<div>
<div>
<div><a>C#</a></div>
</div>
<div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">UtilityClass.MethodA();  
</pre>
</div>
</div>
</div>
</div>
<p>对于只对输入参数进行运算而不获取或设置任何内部实例字段的方法集，静态类可以方便地用作这些方法集的容器。 例如，在 .NET Framework 类库中，静态类&nbsp;<a href="https://msdn.microsoft.com/zh-cn/library/system.math.aspx" rel="external nofollow noreferrer">System.Math</a>&nbsp;包含的方法只执行数学运算，而无需存储或检索特定&nbsp;<a href="https://msdn.microsoft.com/zh-cn/library/system.math.aspx" rel="external nofollow noreferrer">Math</a>&nbsp;类实例特有的数据。 就是说，通过指定类名称和方法名称来应用类成员，如下示例所述。</p>
<div>
<div>&nbsp;</div>
<div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">double dub = -3.14;<br />
Console.WriteLine(Math.Abs(dub));<br />
Console.WriteLine(Math.Floor(dub));<br />
Console.WriteLine(Math.Round(Math.Abs(dub)));  

// Output:<br />
// 3.14<br />
// -4<br />
// 3  
</pre>
</div>
</div>
</div>
</div>
<p>和所有类类型一样，当加载引用静态类的程序时，.NET Framework 公共语言运行时 (CLR) 将加载该静态类的类型信息。程序不能指定加载静态类的确切时间。 但是，可以保证在程序中首次引用该类前加载该类，并初始化该类的字段并调用其静态构造函数。 静态构造函数仅调用一次，在程序驻留的应用程序域的生存期内，静态类一直保留在内存中。</p>
<div>
<table>
<tbody>
<tr>
<th scope="col"><img referrerpolicy="no-referrer"src="https://i-msdn.sec.s-msft.com/dynimg/IC101471.jpeg" />&nbsp;说明</th>
</tr>
<tr>
<td>
<p>若要创建仅允许创建一个自身实例的非静态类，请参见&nbsp;<a href="http://go.microsoft.com/fwlink/?LinkID=100567" rel="external nofollow noreferrer">Implementing Singleton in C#</a>（在 C# 中实现单一实例）。</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>下表介绍静态类的主要特性：</p>
<ul><li><p>仅包含静态成员。</p></li>
<li><p>无法实例化。</p></li>
<li><p>是密封的。</p></li>
<li><p>不能包含<a href="https://msdn.microsoft.com/zh-cn/library/k6sa6h87.aspx" rel="external nofollow noreferrer">实例构造函数</a>。</p></li></ul>
<p>因此，创建静态类与创建仅包含静态成员和私有构造函数的类基本相同。 私有构造函数阻止类被实例化。 使用静态类的优点在于，编译器能够执行检查以确保不致偶然地添加实例成员。 编译器将保证不会创建此类的实例。</p>
<p>静态类是密封的，因此不可被继承。 它们不能从除&nbsp;<a href="https://msdn.microsoft.com/zh-cn/library/system.object.aspx" rel="external nofollow noreferrer">Object</a>&nbsp;外的任何类中继承。 静态类不能包含实例构造函数，但可以包含静态构造函数。 如果非静态类包含需要进行重要的初始化的静态成员，也应定义静态构造函数。 有关更多信息，请参见&nbsp;<a href="https://msdn.microsoft.com/zh-cn/library/k9x6w0hc.aspx" rel="external nofollow noreferrer">静态构造函数</a>。</p>
<div>
<div><a>示例</a></p>
<div>&nbsp;</div>
<div>&nbsp;</div>
</div>
<div>&nbsp;</div>
</div>
<p>下面是一个静态类的示例，它包含两个在摄氏温度和华氏温度之间执行来回转换的方法：</p>
<div>
<div>
<div><a>C#</a></div>
</div>
<div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">    public static class TemperatureConverter<br />
    {<br />
        public static double CelsiusToFahrenheit(string temperatureCelsius)<br />
        {<br />
            // Convert argument to double for calculations.<br />
            double celsius = Double.Parse(temperatureCelsius);

            // Convert Celsius to Fahrenheit.<br />
            double fahrenheit = (celsius * 9 / 5) + 32;

            return fahrenheit;<br />
        }

        public static double FahrenheitToCelsius(string temperatureFahrenheit)<br />
        {<br />
            // Convert argument to double for calculations.<br />
            double fahrenheit = Double.Parse(temperatureFahrenheit);

            // Convert Fahrenheit to Celsius.<br />
            double celsius = (fahrenheit - 32) * 5 / 9;

            return celsius;<br />
        }<br />
    }

    class TestTemperatureConverter<br />
    {<br />
        static void Main()<br />
        {<br />
            Console.WriteLine("Please select the convertor direction");<br />
            Console.WriteLine("1. From Celsius to Fahrenheit.");<br />
            Console.WriteLine("2. From Fahrenheit to Celsius.");<br />
            Console.Write(":");

            string selection = Console.ReadLine();<br />
            double F, C = 0;

            switch (selection)<br />
            {<br />
                case "1":<br />
                    Console.Write("Please enter the Celsius temperature: ");<br />
                    F = TemperatureConverter.CelsiusToFahrenheit(Console.ReadLine());<br />
                    Console.WriteLine("Temperature in Fahrenheit: {0:F2}", F);<br />
                    break;

                case "2":<br />
                    Console.Write("Please enter the Fahrenheit temperature: ");<br />
                    C = TemperatureConverter.FahrenheitToCelsius(Console.ReadLine());<br />
                    Console.WriteLine("Temperature in Celsius: {0:F2}", C);<br />
                    break;

                default:<br />
                    Console.WriteLine("Please select a convertor.");<br />
                    break;<br />
            }

            // Keep the console window open in debug mode.<br />
            Console.WriteLine("Press any key to exit.");<br />
            Console.ReadKey();<br />
        }<br />
    }<br />
    /* Example Output:<br />
        Please select the convertor direction<br />
        1. From Celsius to Fahrenheit.<br />
        2. From Fahrenheit to Celsius.<br />
        :2<br />
        Please enter the Fahrenheit temperature: 20<br />
        Temperature in Celsius: -6.67<br />
        Press any key to exit.<br />
     */
</pre>
</div>
</div>
</div>
</div>
<div>
<div><a>静态成员</a></p>
<div>&nbsp;</div>
<div>&nbsp;</div>
</div>
<div>&nbsp;</div>
</div>
<p>非静态类可以包含静态的方法、字段、属性或事件。 即使没有创建类的实例，也可以调用该类中的静态成员。 始终通过类名而不是实例名称访问静态成员。 无论对一个类创建多少个实例，它的静态成员都只有一个副本。 静态方法和属性不能访问其包含类型中的非静态字段和事件，并且不能访问任何对象的实例变量（除非在方法参数中显式传递）。</p>
<p>更常见的做法是声明具有一些静态成员的非静态类，而不是将整个类声明为静态类。 静态字段有两个常见的用法：一是记录已实例化对象的个数，二是存储必须在所有实例之间共享的值。</p>
<p>静态方法可以被重载但不能被重写，因为它们属于类，不属于类的任何实例。</p>
<p>虽然字段不能声明为&nbsp;<code>static const</code>，但&nbsp;<a href="https://msdn.microsoft.com/zh-cn/library/e6w8fe1b.aspx" rel="external nofollow noreferrer">const</a>&nbsp;字段的行为在本质上是静态的。 这样的字段属于类型，不属于类型的实例。 因此，可以同对待静态字段一样使用&nbsp;<code>ClassName.MemberName</code>&nbsp;表示法来访问 const 字段。 不需要对象实例。</p>
<p>C# 不支持静态局部变量（在方法范围内声明的变量）。</p>
<p>通过在成员的返回类型之前使用&nbsp;<code>static</code>&nbsp;关键字可以声明静态类成员，如下面的示例所示：</p>
<div>
<div>
<div><a>C#</a></div>
</div>
<div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">    public class Automobile<br />
    {<br />
        public static int NumberOfWheels = 4;<br />
        public static int SizeOfGasTank<br />
        {<br />
            get<br />
            {<br />
                return 15;<br />
            }<br />
        }<br />
        public static void Drive() { }<br />
        public static event EventType RunOutOfGas;

        // Other non-static fields and properties...<br />
    }
</pre>
</div>
</div>
</div>
</div>
<p>静态成员在第一次被访问之前并且在调用静态构造函数（如有存在）之前进行初始化。 若要访问静态类成员，应使用类名而不是变量名来指定该成员的位置，如下面的示例所示：</p>
<div>
<div>
<div><a>C#</a></div>
</div>
<div>
<div>&nbsp;</div>
<div>
<div>
<pre class="prettyprint linenums">            Automobile.Drive();<br />
            int i = Automobile.NumberOfWheels;
</pre>
</div>
</div>
</div>
</div>
<p>如果类包含静态字段，请提供在加载类时初始化这些字段的静态构造函数。</p>
<p>对静态方法的调用以 Microsoft 中间语言 (MSIL) 生成调用指令，而对实例方法的调用生成&nbsp;<code>callvirt</code>&nbsp;指令，该指令还检查 null 对象引用。 但是，两者之间的性能差异在大多数时候并不明显。</p>
<p>原文地址：<a href="https://msdn.microsoft.com/zh-cn/library/79b3xss3.aspx" rel="external nofollow noreferrer">https://msdn.microsoft.com/zh-cn/library/79b3xss3.aspx</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy52gj9.html">页面上常用的一些小功能--QQ、回到顶部</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9372rg8.html">&lbrack;2015hdu多校联赛补题&rsqb;hdu5384 Danganronpa</a>
		</li>
						<li><a href="https://www.batexi.com/a/495zy6m9.html">hibernate常用API详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vm0ym8.html">264&period; Ugly Number II</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1kndx9.html">【EF Code First】 一对一、一对多的多重关系配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15rwx9.html">【转】从零开始编写自己的C&num;框架（7）&mdash;&mdash;需求分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0n3w0q.html">IOS开发之路四（UITabBarController）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeojvx9.html">hadoop2 作业执行过程之yarn调度执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okl7j9.html">给destoon商城的列表中和首页添加购物车功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn3rpz8.html">SSH端口修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzjmg08.html">mfc主窗口添加背景图片后，如何实现在背景图片上输出文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjjljg8.html">【剑指offer】面试题39：深度二叉树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppddj9.html">HDU 1054 Strategic Game（树形DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljj7509.html">第一篇&mdash;&mdash;第一文 SQL Server 备份基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp4040q.html">Chipmunk僵尸物理对象的出现和解决&lpar;四&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3n1x9.html">LIRe 源代码分析 2：基本接口（DocumentBuilder）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1y03yq.html">MIP 移动网页加速器视频教程全新发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvmje28.html">SpringBoot Tomcat启动报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5nyvdq.html">Python 爬虫实例&lpar;爬百度百科词条&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2do2oq.html">oath2</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xom4w9.html">C语言中的二维数组和数组指针的那些事</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdk6vr8.html">C&num;占位符与格式化字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wdr03q.html">通过继承Rect类编写一个具有确定位置的矩形类PlainRect，其确定位置用 矩形的左上角坐标来标识，包含： 添加两个属性：矩形左上角坐标startX和startY。 两个构造方法： 带4个参数的构造方法，用于对startX、startY、width和height属性 初始化； 不带参数的构造方法，将矩形初始化为左上角坐标、长和宽都为0 的矩形； 添加一个方法： 判断某个点是否在矩形内部的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdk7dl8.html">FZU 2144 Shooting Game</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1ep7e9.html">CSS在线字体库，外部字体的引用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1116n9.html">&lbrack;SAP ABAP开发技术总结&rsqb;程序自己以JOB方式运行</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vvmyn8.html">Using SSH on Linux</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z11om19.html">Python基础学习笔记（十三）异常</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmmp5z9.html">I2总线</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyddvggq.html">2013 Multi-University Training Contest 10</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
